import es
import cfglib
import gamethread

info = es.AddonInfo()
info.name			=	'Custom Script Loader'
info.basename		=	'csl'
info.version		=	'1.2'
info.author			=	'scaiyth'
info.url			=	'http://addons.eventscripts.com/addons/view/' + info.basename
info.description	=	"Auto loads and unloads one or more scripts + a config file on certain (predefined) maps"

csl_var				=	es.ServerVar(info.basename, info.version, info.name + ': ' + info.description + '\n// by ' + info.author)

csl_config			=	cfglib.AddonCFG(es.getAddonPath(info.basename) + "/config.cfg", 1)
csl_maps			=	csl_config.cvar('csl_maps', '', 'Mapnames or parts of mapnames (e.g. prefixes) which trigger CSL to load the script')
csl_except_maps		=	csl_config.cvar('csl_except_maps', '', 'Mapnames which CSL will ignore for loading')
csl_loadscripts		=	csl_config.cvar('csl_loadscripts', '', 'Script(s) that will be loaded on csl_maps')
csl_unloadscripts	=	csl_config.cvar('csl_unloadscripts', '', 'Script(s) that will be unloaded on csl_maps')
csl_configfile		=	csl_config.cvar('csl_configfile', '', 'Name of a config file that will be executed on mapstart on csl_maps')
csl_configfile2		=	csl_config.cvar('csl_configfile2', '', 'Name of a config file that will be executed when returning to non-csl_maps')
csl_auto_restore	=	csl_config.cvar('csl_auto_restore', 1, 'Enable/Disable unloading the script on normal maps')

prev_cslmap = 0

def load():
	global prev_cslmap
	csl_var.set(info.version)
	csl_var.makepublic()
	csl_config.execute()
	prev_cslmap = script_map_check()

def es_map_start(event_var):
	global prev_cslmap
	script_unloadconfig = 0
	script_cslmap = script_map_check(event_var['mapname'])
	if script_cslmap:
		if csl_unloadscripts != "":
			for script_scriptname in str(csl_unloadscripts).replace(" ", "").split(","):
				if script_loaded_check(script_scriptname): gamethread.queue(es.unload, script_scriptname)
		if csl_loadscripts != "":
			for script_scriptname in str(csl_loadscripts).replace(" ", "").split(","):
				if not script_loaded_check(script_scriptname): gamethread.queue(es.load, script_scriptname)
		if csl_configfile != "": gamethread.queue(es.delayed, ('1', 'exec "%s"' % csl_configfile))
	elif prev_cslmap and csl_auto_restore and not script_cslmap:
		if csl_loadscripts != "":
			for script_scriptname in str(csl_loadscripts).replace(" ", "").split(","):
				if script_loaded_check(script_scriptname): gamethread.queue(es.unload, script_scriptname)
		if csl_unloadscripts != "":
			for script_scriptname in str(csl_unloadscripts).replace(" ", "").split(","):
				if not script_loaded_check(script_scriptname): gamethread.queue(es.load, script_scriptname)
		if csl_configfile2 != "":
			gamethread.queue(es.delayed, ('1', 'exec server.cfg'))
			gamethread.queue(es.delayed, ('1.5', 'exec "%s"' % csl_configfile2))
	prev_cslmap = script_cslmap

def script_loaded_check(script):
	if script != "":
		if es.exists('script', script):
			return 1
		else:
			for scriptname in es.addons.getAddonList():
				scriptstring = str(scriptname.__name__)
				if scriptstring == script + '.' + script:
					return 1
	return 0

def script_map_check(map = es.ServerVar('eventscripts_currentmap')):
	map = str(map).lower()
	if map != "":
		if csl_except_maps != "":
			for script_except_map in str(csl_except_maps).replace(" ", "").split(","):
				if script_except_map.lower() == map:
					return 0
		for script_map in str(csl_maps).replace(" ", "").split(","):
			if script_map.lower() in map and script_map != "":
				return 1
		else:
			return 0
	else:
		return 0
